package unsereliste;

public class ArrayList<E> implements List<E> {
	private E[] store;
	private int theSize = 0;

	public ArrayList() {
		this(10);
	}
	@SuppressWarnings("unchecked")
	public ArrayList(int initialCapacity) {
		store = (E[]) new Object[initialCapacity];
	}

	@Override
	public int size() {
		return theSize;
	}

	@Override
	public void add(E e) {
		if (theSize >= store.length)
			getNewStore();
		store[theSize] = e;
		theSize = theSize + 1;
	}

	private void getNewStore() {
		@SuppressWarnings("unchecked")
		E[] theNewStore = (E[]) new Object[store.length + 10];
		for (int i = 0; i < store.length; i++) {
			theNewStore[i] = store[i];
		}
		store = theNewStore;
	}

	@Override
	public E get(int i) {
		return store[i];
	}

}
