package unsereliste;

public interface List<E> {
	int size();
	void add(E e);
	E get(int i);
	
	default void fuerAlle(Konsument<? super E> konsum) {
		for (int i = 0; i < size(); i++)
			konsum.komsumiere(get(i));
	}
	static <A>  List<A> of(A...as){
		var result = new ArrayList<A>(as.length);
		for (var a:as) result.add(a);
		return result;
	}
}
